-- DialogueTrigger
-- Made by SajberToffe

Script:LoadScript("scripts/XMLParser.lua");
Script:LoadScript("scripts/Network.lua");

ST_DialogTrigger = {
	Properties = {
		Size = {
			DimX = 5,
			DimY = 5,
			DimZ = 5,
		},
		fileXMLFile = "dialog.xml",
		fileLocalized = "localized.xml",
		iDialog = 1,
		bEnableOnEnter = 1,
		bActiveAtStart = 1,
	},
	parser = nil,
	--players = nil,
}

ST_DialogTrigger_Query = "1";
ST_DialogTrigger_Response = "2";
ST_DialogTrigger_ClientShutdown = "3";
ST_DialogTrigger_SetFlag = "4";
ST_DialogTrigger_SetPlayerFlag = "5";
ST_DialogTrigger_UpdateFlags = "6";

ST_DialogTrigger_GotoCallback = {
 	OnEvent = function(self, event, params)
 		--System:Log("Goto callback");
		params.entity:SendNextSection(params.slot, params.section)
 	end,
}

function GetModPath()
   	local mods = Game:GetModsList()
   	for i, val in mods do
		if(val.CurrentMod)then
		   	return val.Folder;
		end
   	end
   	return "No mod loaded"; -- should never happen...
end



function ST_DialogTrigger:OnReset()
	-- ClientStuff and Gamerules is always loaded before the entities...
	if(ClientStuff)then
	   	ClientStuff.OnServerCmd = Network_OnServerCmd;
	end

	if(GameRules)then
		GameRules.OnClientCmd = Network_OnClientCmd;
	end

	if(self.Properties.fileLocalized ~= "")then
	   	Language:LoadStringTable(self.Properties.fileLocalized)
	end


	local Min = { x = -self.Properties.Size.DimX / 2, y = -self.Properties.Size.DimY / 2, z = -self.Properties.Size.DimZ / 2 };
	local Max = { x = self.Properties.Size.DimX / 2, y = self.Properties.Size.DimY / 2, z = self.Properties.Size.DimZ / 2  };
	self:SetBBox( Min, Max );
    --self.players = {};
    self.Data = { flags = {}, player = { flags = {}, }, };
  	self.parser = new(XMLParser);
  	local ret;
  	System:Log("Searching in: " .. GetModPath() .. "\\Levels\\" .. Game:GetLevelName() .. "\\" .. self.Properties.fileXMLFile);
	ret = self.parser:ParseFile(GetModPath() .. "\\Levels\\" .. Game:GetLevelName() .. "\\" .. self.Properties.fileXMLFile);
	System:Log(type(ret));
	if(not ret)then
  		System:Log("Searching in: " .. GetModPath() .. "\\" .. self.Properties.fileXMLFile);
		ret = self.parser:ParseFile(GetModPath() .. "\\" .. self.Properties.fileXMLFile);
	end
	if(not ret)then
  		System:Log("Searching in: " .. "Levels\\" .. Game:GetLevelName() .. "\\" .. self.Properties.fileXMLFile);
		ret = self.parser:ParseFile("Levels\\" .. Game:GetLevelName() .. "\\" .. self.Properties.fileXMLFile);
	end
	if(not ret)then
  		System:Log("Searching in: " .. self.Properties.fileXMLFile);
		ret = self.parser:ParseFile(self.Properties.fileXMLFile);
	end
	if(not ret)then
		System:Log("No xml file found!");
	end

	if(Game:IsServer())then
		if(self.Properties.bActiveAtStart == 1)then
			self:GotoState("Active");
		else
			self:GotoState("Inactive");
		end
	end

	Hud:EnableCustomHud(1);

	self.hudOptionsStart = 1;
	self.hudTextLines = { n = 0 };
	self.hudOptions = { n = 0 };
	self.keyPressOption = {};
	self.hudText = "";
	self.hudTitle = "";
	self.bShowHud = nil;
end

function ST_DialogTrigger:RegisterStates()
	self:RegisterState("Active");
	self:RegisterState("Inactive");
end

function ST_DialogTrigger:OnUpdateCustomHud()
   	if(self.bShowHud)then
   		--Hud.white_dot;

		local x, y = 100 + 10, 50 + 22 + 10;

		%System:DrawImageColor(Hud.white_dot, 100, 50, 600, 500, 4, 0.3, 0.3, 0.3, 0.6);
		Game:WriteHudString(10 + 100, 10 + 50, "$6" .. self.hudTitle, 1, 1, 1, 1, 22, 22);
		
		local maxLines = (self.hudTextLines.n > 22) and 22 or self.hudTextLines.n;

		for i = 1, maxLines do
		   	Game:WriteHudString(x, y + (i - 1) * 16, self.hudTextLines[i], 1, 1, 1, 1, 16, 16);
		end

		--maxLines = (self.hudOptions.n - self.hudOptionsStart > 5) and 5 or (self.hudOptions.n - self.hudOptionsStart);
		--self.hudOptionsStart = 1;

		--local optionStr;

		for i = 1, self.hudOptions.n do
 		   	Game:WriteHudString(x, 16 * i + 432, self.hudOptions[i], 1, 1, 1, 1, 16, 16);

-- 			if(i == maxLines and (self.hudOptions.n > 5))then
-- 				Game:WriteHudString(x, 16 * i + 432, maxLines .. ". More", 1, 1, 1, 1, 16, 16);
-- 				if(maxLines < 5)then
-- 					self.keyPressOption[maxLines] = -1;
-- 				else
-- 					self.keyPressOption[maxLines] = -2;
-- 				end
-- 				local j = maxLines + 1;
-- 				while(j <= 5)do
-- 					self.keyPressOption[j] = nil;
-- 					j = j + 1;
-- 				end
-- 			else
-- 				optionStr = i .. ". " .. tostring(self.hudOptions[i + self.hudOptionsStart]);
-- 				if(strlen(optionStr) > 48)then
-- 				   	optionStr = strsub(optionStr, 1, 48);
-- 				end
-- 		   		Game:WriteHudString(x, 16 * i + 432, optionStr, 1, 1, 1, 1, 16, 16);
-- 				self.keyPressOption[i] = i + self.hudOptionsStart;
-- 		   	end
		end
		
		self.lastKey = self.keyDown;
		self.keyDown = Input:GetXKeyDownName();
		if(self.lastKey and not self.keyDown)then
			local num = tonumber(self.lastKey);
		   	if(num and (num > 0 and num < 6) and self.keyPressOption[num])then
		   		if(self.keyPressOption[num] < 0)then
		   			if(self.keyPressOption[num] == -1)then
						self.hudOptionsStart = 1;
					else
						self.hudOptionsStart = self.hudOptionsStart + 4;
					end
					self:DisplayDialog(self.dialog, self.section);
		   		else
		   		   	Network:ServerCommand(self.id, ST_DialogTrigger_Query,
							self.dialog, self.section, self.keyPressOption[num]);
		   		end
		   	end
		end
   	end
end

function ST_DialogTrigger:AddHudText(str)
	self.hudText = self.hudText .. str;
	self:FormatText();
end

function ST_DialogTrigger:SetHudText(str)
	self.hudText = str;
	self:FormatText();
end

function ST_DialogTrigger:FormatText()
	local text = {};
	gsub(self.hudText, "([^ ]+)", function(s) tinsert(%text, s) end);
	local width, height;
	self.hudTextLines = {};
	local line = "";
	local n = getn(text);
	local b, e, newLine;
	local i = 1;
	while(text[i])do
		b, e = strfind(text[i], strchar(10));     -- ascii 10 = \n
		if(b)then
			line = line .. strsub(text[i], 1, b - 1);
			tinsert(self.hudTextLines, line .. " ");
			text[i] = strsub(text[i], e + 1);
			line = "";
			i = i - 1;
		else
			width, height = %Game:GetHudStringSize(line .. " " .. text[i], 16, 16);

			if(not text[i + 1])then
				tinsert(self.hudTextLines, line .. text[i]);
			elseif(width > 590)then
				tinsert(self.hudTextLines, line);
				line = text[i] .. " ";
			else
				line = line .. text[i] .. " ";
			end
		end
		i = i + 1;
	end
end

function ST_DialogTrigger:EnableInterface(bEnable)
   	Game:EnableUIOverlay(bEnable and 1 or 0, 0);
	self.bShowHud = bEnable;
end

function ST_DialogTrigger:OnShutDown()
   	Game:EnableUIOverlay(0, 0);
end

function ST_DialogTrigger:DisplayDialog(dialog, section)
	if(Hud)then
	   	--local guiBox = Hud:GetHudItem("DialogTextItem");
	   	self.dialog = dialog;
	   	self.section = section;
	   	local dialogElement = self.parser:GetElementByTagName("Dialog", self.Properties.iDialog);
	   	if(not dialogElement)then
	   	   	System:Error("XML Error: No <Dialog> tag found");
	   	   	return nil;
	   	end
	   	local sectionElement = self.parser:GetElementByTagName("Section", section, dialogElement);
	   	if(not sectionElement)then
	   	   	System:Error("XML Error: The requested <Section> tag not found!");
	   	   	return nil;
	   	end
	   	local optionElements = self.parser:GetElementsByTagName("Option", sectionElement);
	   	local outputElement = self.parser:GetElementByTagName("Output", 1, sectionElement);
	   	--self.parser:DumpElement(output);
	   	--System:Log("output: [" .. tostring(self.parser:GetText(outputElement)) .. "]");
	   	--guiBox:GetContentItem("Output"):SetText(self.parser:GetText(outputElement));
	   	self.hudTitle = dialogElement.attributes["title"] or "";
	   	self:SetHudText(self.parser:GetText(outputElement));
	   	--guiBox:GetContentItem("Output"):AddText("\n");
	   	--System:Log("n: " .. getn(options));

	   	--dumpTable(options);

		local option;
		local legal;
		local conditions;
		local j = 1; -- self.hudOptionsStart;
		local n = 0;
		self.hudOptions = { n = 0 };
	   	local maxLines = (optionElements.n - (self.hudOptionsStart - 1) > 5) and 5 or (5 - mod(optionElements.n, 4));
	   	System:Log("maxLines " .. maxLines );
--	   	maxLines = (maxLines > 0) and maxLines or 5;
	   	for i = self.hudOptionsStart, optionElements.n + 1 do
	   		if(j > 5)then
	   			break;
	   		end
			legal = 1;
		    conditions = self.parser:GetElementByTagName("Conditions", 1, optionElements[i]);
		    if(conditions)then
		    	for i = 1, conditions.childNodes.n do
		    		if(not self:InterpretCondition(conditions.childNodes[i].tagName,
							conditions.childNodes[i].attributes, self.Data, self.Data.player))then
		    	   		legal = nil;
		    	   		--break;
		    		end
		    	end
		    end
		    if(legal)then
		    	if((j == maxLines) and (optionElements.n > 5))then
		    		tinsert(self.hudOptions, tostring(maxLines .. ". More"));
		    		if(maxLines < 5)then
						self.keyPressOption[maxLines] = -1;
					else
						self.keyPressOption[maxLines] = -2;
					end
					local k = maxLines + 1;
					while(k <= 5)do
						self.keyPressOption[k] = nil;
						k = k + 1;
					end
					break;
				elseif(optionElements[i])then
			    	tinsert(self.hudOptions, j .. ". " .. tostring(optionElements[i].attributes["value"]));
					self.keyPressOption[j] = i;
				end
				j = j + 1;
			end
	   	end

		--self.hudOptionsStart = 1;

-- 		local optionStr;
-- 
-- 		for i = 1, maxLines do
-- 			if(i == maxLines and (self.hudOptions.n > 5))then
-- 				Game:WriteHudString(x, 16 * i + 432, maxLines .. ". More", 1, 1, 1, 1, 16, 16);
-- 				if(maxLines < 5)then
-- 					self.keyPressOption[maxLines] = -1;
-- 				else
-- 					self.keyPressOption[maxLines] = -2;
-- 				end
-- 				local j = maxLines + 1;
-- 				while(j <= 5)do
-- 					self.keyPressOption[j] = nil;
-- 					j = j + 1;
-- 				end
-- 			else
-- 				optionStr = i .. ". " .. tostring(self.hudOptions[i + self.hudOptionsStart]);
-- 				if(strlen(optionStr) > 48)then
-- 				   	optionStr = strsub(optionStr, 1, 48);
-- 				end
-- 		   		Game:WriteHudString(x, 16 * i + 432, optionStr, 1, 1, 1, 1, 16, 16);
-- 		   	end
-- 		end

		self:EnableInterface(1);
	   	--guiBox:Activate();
-- 	   	if(getn(optionElements) < 1)then
-- 	   		guiBox:Deactivate();
-- 	   	end
	end
end

function ST_DialogTrigger:CreateSlotData()
   	local data = {};
   	data.flags = {};
   	return data;
end

function ST_DialogTrigger:SendNextSection(slot, section)
    --Network:SlotCommand(slot, self.id, ST_DialogTrigger_Response, self.Properties.iDialog, section);
    
-- ARJ ADDED
System:Log("Response");
if(self.Properties.iDialog and section)then
System:Log("dialog and section found");
self.hudOptionsStart = 1;
self:EnableInterface(1);
self:DisplayDialog(self.Properties.iDialog, section);
else
System:Log("No dialog and section");
--Hud:GetHudItem("DialogTextItem"):Deactivate();
self:EnableInterface(nil);
end
-- END ARJ ADDED

   	local dialogElement = self.parser:GetElementByTagName("Dialog", self.Properties.iDialog);
   	local sectionElement = self.parser:GetElementByTagName("Section", section, dialogElement);
   	local triggersElement = self.parser:GetElementByTagName("Triggers", 1, sectionElement);
   	local legal;

   	if(triggersElement)then
       	for i = 1, triggersElement.childNodes.n do
			legal = 1;
		    conditions = self.parser:GetElementByTagName("Conditions", 1, triggersElement.childNodes[i]);
		    if(conditions)then
		    	for j = 1, conditions.childNodes.n do
		    		if(not self:InterpretCondition(conditions.childNodes[j].tagName,
							conditions.childNodes[j].attributes, self.Data, self.Data[slot]))then
		    	   		legal = nil;
		    	   		break;
		    		end
		    	end
		    end
		    if(legal)then
       	   		self:InterpretTrigger(slot, triggersElement.childNodes[i].tagName, 
						triggersElement.childNodes[i].attributes, dialog, section);
       	   	end
       	end
    end
end

function ST_DialogTrigger:InterpretTrigger(slot, tagName, attributes, dialog, section)
   	if(tagName == "SetFlag")then
   		local flag = tonumber(attributes["flagId"]) or 1;
   		local value = tonumber(attributes["value"]);
   		System:Log("flag " .. tostring(flag) .. " set to " .. tostring(value));
   	   	self.Data.flags[flag] = (value == 0) and 0 or 1;
   	   	Network:SlotCommand(slot, self.id, ST_DialogTrigger_SetFlag, flag, self.Data.flags[flag]);
   	elseif(tagName == "ToggleFlag")then
   		local flag = tonumber(attributes["flagId"]) or 1;
   		local value = tonumber(attributes["value"]);
   		System:Log("flag " .. tostring(flag) .. " set to " .. tostring(value));
   	   	self.Data.flags[flag] = (value == 1) and 0 or 1;
   	   	Network:SlotCommand(slot, self.id, ST_DialogTrigger_ToggleFlag, flag, self.Data.flags[flag]);
   	elseif(tagName == "SetPlayerFlag")then
   		local flag = tonumber(attributes["flagId"]) or 1;
   		local value = tonumber(attributes["value"]);
   		System:Log("player flag " .. tostring(flag) ..  " set to " .. tostring(value));
   	   	self.Data[slot].flags[flag] = (value == 0) and 0 or 1;
   	   	Network:SlotCommand(slot, self.id, ST_DialogTrigger_SetPlayerFlag, flag, self.Data[slot].flags[flag]);
   	elseif(tagName == "TogglePlayerFlag")then
   		local flag = tonumber(attributes["flagId"]) or 1;
   		local value = tonumber(attributes["value"]);
   	   	self.Data[slot].flags[flag] = (value == 1) and 0 or 1;
   	   	Network:SlotCommand(slot, self.id, ST_DialogTrigger_TogglePlayerFlag, flag, self.Data[slot].flags[flag]);
   	elseif(tagName == "Goto")then
   		local delay = tonumber(attributes["delay"]);
   		local section = tonumber(attributes["section"]) or 1;
   		System:Log("going to section " .. section);
   		if(delay)then
			self.gotoTimer = Game:SetTimer( ST_DialogTrigger_GotoCallback, delay, { entity = self, slot = slot, section = section});
		else
			self:SendNextSection(slot, section)
		end
   	elseif(tagName == "Event")then
   		local entity = System:GetEntity(attributes["entityId"]) or System:GetEntity(tonumber(attributes["entityId"])) or self;
   		local event = attributes["eventId"];
   		if(entity and event)then
   			local callback = entity["Event_" .. event];
   			if(callback)then
   		   		callback(entity, self);
   		   	end
   		end
   	elseif(tagName == "SetStartSection")then
   		local value = tonumber(attributes["value"]) or section or 1;
   	   	self.Data[slot].startSection = (value > 0) and value or 1;
   	elseif(tagName == "Log")then
   		if attributes["value"] then
   			System:Log(attributes["value"]);
   		end
   	end
end

function ST_DialogTrigger.eq(lhs, rhs)
	System:Log(tostring (lhs));
	System:Log(tostring (rhs));
	lhs = lhs or 0;
	return (lhs and rhs) and (lhs == rhs);
end

function ST_DialogTrigger.gt(lhs, rhs)
	System:Log(tostring (lhs));
	System:Log(tostring (rhs));
	lhs = lhs or 0;
	return (lhs and rhs) and (lhs == rhs);
end

function ST_DialogTrigger.lt(lhs, rhs)
	System:Log(tostring (lhs));
	System:Log(tostring (rhs));
	lhs = lhs or 0;
	return (lhs and rhs) and (lhs == rhs);
end

function ST_DialogTrigger.set(lhs, rhs)
	System:Log(tostring (lhs));
	System:Log(tostring (rhs));
	--lhs = lhs or 0;
	return (lhs and tonumber(lhs) ~= 0);
end

function ST_DialogTrigger:InterpretCondition(tagName, attributes, globalTbl, playerTbl)
	local flagId = tonumber(attributes["flagId"]) or 1;

	local tbl = (tagName == "PlayerFlag") and playerTbl or
				(tagName == "Flag") and globalTbl;
				
	local field = "flags";

	local value = 	tonumber(attributes["equals"]) or
					tonumber(attributes["isLessThan"]) or
					tonumber(attributes["isGreaterThan"]) or
					tonumber(attributes["value"]) or
					1;

	local op = 	attributes["equals"] and self.eq or
				attributes["isLessThan"] and self.lt or
				attributes["isGreaterThan"] and self.gt or
				attributes["value"] and self.eq or
				self.set;
				
	local _op = attributes["equals"] and "equals" or
				attributes["isLessThan"] and "isLessThan" or
				attributes["isGreaterThan"] and "isGreaterThan" or
				"set";

	System:Log("tbl:" .. tostring(tbl) .. " op: " .. _op .. " flagId: " .. flagId .. " value: " .. value);

	--if(tagName == "PlayerFlag")then
	return tbl and op(tbl[field][flagId], value) or nil;
	--elseif(tagName == "Flag")then
	--	return op(globalTbl.flags[tonumber(attributes["flagId"])], value);
	--elseif(unknownVariable == 1)then -- Player stats...

	--else
		--System:Log("Condition unknown");
	--end
end

-- function ST_DialogTrigger:Server_InterpretCondition(slot, tagName, attributes)
-- 	if(tagName == "PlayerFlag")then
-- 		if(self.Data[slot].flags[tonumber(attributes["flagId"])] == (tonumber(attributes["value"]) or 1))then
-- 			return 1;
-- 		end
-- 	elseif(tagName == "Flag")then
-- 		if(self.Data["flags"][tonumber(attributes["flagId"])] == (tonumber(attributes["value"]) or 1))then
--            	return 1;
-- 		end
-- 	else   
-- 		--System:Log("Condition unknown");
-- 	end
-- end
-- 
-- function ST_DialogTrigger:Client_InterpretCondition(tagName, attributes)
-- 	if(tagName == "PlayerFlag")then
-- 		if(self.Data.playerFlags[tonumber(attributes["flagId"])] == (tonumber(attributes["value"]) or 1))then
-- 			--System:Log("playerFlag " .. tonumber(attributes["flagId"]) .. " is " .. (tonumber(attributes["value"]) or 1));
-- 			return 1;
-- 		end
-- 	elseif(tagName == "Flag")then
-- 		if(self.Data.flags[tonumber(attributes["flagId"])] == (tonumber(attributes["value"]) or 1))then
-- 			--System:Log("flag " .. tonumber(attributes["flagId"]) .. " is " .. (tonumber(attributes["value"]) or 1));
--            	return 1;
-- 		end
-- 	else
-- 		--System:Log("Condition " .. tagName .. " is unknown");
-- 	end
-- end

function ST_DialogTrigger:Event_Activate(self, sender)
	if(self:GetState() ~= "Active")then
	   	self:GotoState("Active");
	end
end

function ST_DialogTrigger:Event_Deactivate(self, sender)
	if(self:GetState() ~= "Inactive")then
	   	self:GotoState("Inactive");
	end
end

function ST_DialogTrigger:Event_TriggerEvent0(self, sender)
	BroadcastEvent(self, "TriggerEvent0");
end

function ST_DialogTrigger:Event_TriggerEvent1(self, sender)
	BroadcastEvent(self, "TriggerEvent1");
end

function ST_DialogTrigger:Event_TriggerEvent2(self, sender)
	BroadcastEvent(self, "TriggerEvent2");
end

function ST_DialogTrigger:Event_TriggerEvent3(self, sender)
	BroadcastEvent(self, "TriggerEvent3");
end

function ST_DialogTrigger:Event_TriggerEvent4(self, sender)
	BroadcastEvent(self, "TriggerEvent4");
end

function ST_DialogTrigger:Event_TriggerEvent5(self, sender)
	BroadcastEvent(self, "TriggerEvent5");
end

function ST_DialogTrigger:Event_TriggerEvent6(self, sender)
	BroadcastEvent(self, "TriggerEvent6");
end

function ST_DialogTrigger:Event_TriggerEvent7(self, sender)
	BroadcastEvent(self, "TriggerEvent7");
end

function ST_DialogTrigger:Event_TriggerEvent8(self, sender)
	BroadcastEvent(self, "TriggerEvent8");
end

function ST_DialogTrigger:Event_TriggerEvent9(self, sender)
	BroadcastEvent(self, "TriggerEvent9");
end

function ST_DialogTrigger:IsInside(point)
   	local box = self:GetBBox();
   	if((point.x >= box.min.x - 1) and (point.y >= box.min.y - 1) and (point.z - 1 >= box.min.z - 1) and
   		(point.x <= box.max.x + 1) and (point.y <= box.max.y + 1) and (point.z <= box.max.z + 1))then
   		return 1;
	end
end

ST_DialogTrigger.Server = {
	OnInit = function(self)
		System:Log("Server:OnInit");
		self:RegisterStates();
	    self:OnReset();
	end,
	
	OnShutDown = function(self)
		for i, val in self.Data do
		   	if(type(i) == "table")then
		   	   	System:Log(tostring(i));
		   	end
		end
	end,
	

	Commands = {
		[ST_DialogTrigger_ClientShutdown] = function(self, slot, id)
			-- if this player's registered in this zone, remove him
			-- can't get id from the slot, if the player already has disconnected
			-- and thus, the entity has been removed
			--self.players[id] = nil;
			System:Log("Player " .. id .. " disconnected");
			self.Data[slot] = nil;
		end,
		[ST_DialogTrigger_UpdateFlags] = function(self, slot)
			for i, val in self.Data.flags do
                	if(tonumber(val) and tonumber(val) ~= 0)then
   	   					Network:SlotCommand(slot, self.id, ST_DialogTrigger_SetFlag, i, val);
   	   				end
			end
		end,
	},

	Active = {
		Commands = {
			[ST_DialogTrigger_ClientShutdown] = function(self, slot, id)
				-- if this player's registered in this zone, remove him
				-- can't get id from the slot, if the player already has disconnected
				-- and thus, the entity has been removed
				--self.players[id] = nil;
				System:Log("Player " .. id .. " disconnected");
				self.Data[slot] = nil;
			end,
			[ST_DialogTrigger_UpdateFlags] = function(self, slot)
				for i, val in self.Data.flags do
                	if(tonumber(val) and tonumber(val) ~= 0)then
   	   					Network:SlotCommand(slot, self.id, ST_DialogTrigger_SetFlag, i, val);
   	   				end
				end
			end,
			[ST_DialogTrigger_Query] = function(self, slot, dialog, section, option)
				local player = System:GetEntity(slot:GetPlayerId());
			    if(player and PointInsideBBox(player:GetPos(), self, 0.1))then
				   	if(not self.Data[slot])then
				   	   	self.Data[slot] = self:CreateSlotData();
				   	end

				   	--System:Log("Query on server");
	
			    	dialog = dialog or self.Properties.iDialog;
			    	--System:Log("Dialog: " .. dialog);
			    	section = section or self.Data[slot].startSection or 1;
			    	--System:Log("Section: " .. section);
	
				   	local dialogElement = self.parser:GetElementByTagName("Dialog", dialog);
				   	local sectionElement = self.parser:GetElementByTagName("Section", section, dialogElement);
				   	local optionElements = self.parser:GetElementsByTagName("Option", sectionElement);
	
			       	if(option)then
						local legal = 1;
						if(not optionElements[option])then
						   	legal = nil;
						else
				       		local conditions = self.parser:GetElementByTagName("Conditions", 1, optionElements[option]);
				       		if(conditions)then
					       		for i = 1, conditions.childNodes.n do
					       			if(not self:InterpretCondition(conditions.childNodes[i].tagName,
											conditions.childNodes[i].attributes, self.Data, self.Data[slot]))then
					       			   	legal = nil;
					       			   	break;
					       			end
					       		end
					       	end
			       		end
				       	if(legal)then
				       		local newSection = tonumber(optionElements[option].attributes["next"]);
				       		self:SendNextSection(slot, newSection);
				       	else
				       		System:Log("Client requested illegal option!");
				       	end
			       	else
				       	self:SendNextSection(slot, section);
			       	end
			    else
			    	System:Log("Player outide bbox");
			    end
			end,
		},
	},

	Inactive = {

	},
}

ST_DialogTrigger.Client = {
	OnInit = function(self)
	    self:RegisterStates();
	    self:OnReset();
	end,
	
	OnShutDown = function(self)
		if(_localplayer)then
	   		Network:ServerCommand(self.id, ST_DialogTrigger_ClientShutdown, _localplayer:GetId());
	   	end
	end,
	
	Commands = {
	  	[ST_DialogTrigger_SetFlag] = function(self, flagId, value)
	  		--System:Log("flag " .. tostring(flagId) .. " (" .. type(flagId) .. ") = " .. tostring(value) .. " (" .. type(value) .. ")");
	  	    self.Data.flags[flagId] = value;
	  	end,
		[ST_DialogTrigger_SetPlayerFlag] = function(self, flagId, value)
	  		--System:Log("playerFlag " .. tostring(flagId) .. " (" .. type(flagId) .. ") = " .. tostring(value) .. " (" .. type(value) .. ")");
	  	    self.Data.player.flags[flagId] = value;
		end,
	},
	
	Active = {
		Commands = {
		  	[ST_DialogTrigger_Response] = function(self, dialog, section)
		  		--System:Log("Response");
		  		if(dialog and section)then
		  			--System:Log("dialog and section found");
	
					self.hudOptionsStart = 1;
					self:DisplayDialog(dialog, section);
				else
		  			--System:Log("No dialog and section");
				   	--Hud:GetHudItem("DialogTextItem"):Deactivate();
				   	self:EnableInterface(nil);
				end
		  	end,
		},

		OnBeginState = function(self)
		    self:EnableUpdate(0);
		    self:TrackColliders(1);
		    Network:ServerCommand(self.id, ST_DialogTrigger_UpdateFlags);
		end,
		
		OnEnterArea = function(self, collider)
--			System:Log("OnEnter1");
-- 		    if(Hud)then
-- 				System:Log("OnEnter2");
-- 				local item = Hud:GetHudItem("DialogTextItem");
-- 				item.dialogEntity = self; -- make this entity the current dialog
-- 		    end

		    if(collider == _localplayer)then -- only register the local client
--				System:Log("OnEnter3");
		    	if(self.Properties.bEnableOnEnter == 1)then
--					System:Log("OnEnter4");
--		    		System:Log("Entered the area! Sending empty query.");
		    		Network:ServerCommand(self.id, ST_DialogTrigger_Query);
		    	else
		       		self:EnableUpdate(1);
		       	end
		    end
		end,
		
		OnLeaveArea = function(self, collider)
-- 		    if(Hud)then
--				local item = Hud:GetHudItem("DialogTextItem");
-- 				item.dialogEntity = nil;
-- 		    end
			self:EnableInterface(nil);

-- 		    if(collider == _localplayer)then -- only register the local client
-- 		       	self:EnableUpdate(0);
-- 		    end
		end,

		OnUpdate = function(self)
			if(_localplayer and _localplayer.use_pressed)then
		    	--System:Log("Entered the area! Sending empty query.");
		    	Network:ServerCommand(self.id, ST_DialogTrigger_Query);
		    	self:EnableUpdate(0);
			end
		end,
 	},
 	Inactive = {

 	},
}